package config

import (
	"os"
)

// Config contains all needed configurations.
type Config struct {
	DatabaseConnection string
	SessionSecret      string
}

// LoadConfig from path.
func LoadConfig() (*Config, error) {
	configuration := Config{
		DatabaseConnection: os.Getenv("BUDGETEER_DB"),
		SessionSecret:      os.Getenv("BUDGETEER_SESSION_SECRET"),
	}

	return &configuration, nil
}
